import React, {useState, useEffect} from 'react'

// import Nouislider from 'nouislider-react'
// import "nouislider/distribute/nouislider.css";
import ReactDOM from 'react-dom'
import Range from 'rc-slider/lib/Range'
import 'rc-slider/assets/index.css'

// import "./AttributeRange.css"

export default function AttributeRange(props) {
  // console.log('rendering AttributeRange with', props)
  const [range, setRange] = useState(props.range)
  const [isActive, setIsActive] = useState(props.range !== undefined)

  useEffect(() => {
    console.log("attribute range updated:", props.range)
    setRange(props.range)
    setIsActive(props.range !== undefined)
  }, [props.range])

  function activated(event) {
    console.log(event.target.checked ? 'activated' : 'deactivated')
    props.updateRange(event.target.checked ? props.extents : undefined)
    // setIsActive(event.target.checked)
  }

  function onSlide(value) {
    console.log('onSlide')
    let newRange = {
      min: Math.round(value[0]),
      max: Math.round(value[1])
    }
    if (newRange.min === range.min && newRange.max === range.max) {
      console.log('ignoring slide')
      return
    }
    props.updateRange(newRange)
  }

  /*onChange = (evt) => {
      var value = this.validateNum(parseInt(evt.target.value, 10), [evt.target.name]);
      this.setState({ [evt.target.name]: value }, function() {console.log(this.state)});
  }

  validateNum(num, name) {
      if(num > this.props.maxRange) return this.props.maxRange;
      if(num < this.props.minRange) return this.props.minRange;
      return num;
  }*/
  const cb = 
    <div className="flex items-baseline">
      <input  type="checkbox" 
              checked={range !== undefined}
              onChange={(event) => activated(event)} />
      <span className="ml-2">{props.label}</span>
    </div>
  
  if (!isActive) {
    return <div>{cb}</div>
  }
  else {
    return (
      <div className="flex flex-col">
        {cb}
        <div className="pl-8 pr-2 mt-2 mb-8">
          <Range  allowCross={false} 
                  min={props.extents.min}
                  max={props.extents.max}
                  value={[range.min, range.max]}
                  onChange={onSlide}></Range>
          {/* <Nouislider value={} range={props.extents}
                      start={[range.min, range.max]}
                      connect
                      onUpdate={onSlide} /> */}
          <div className="mt-4 flex">
            <input  className="ml-2 bg-gray-200 border rounded"
                    type="number" name="minValue"
                    placeholder="Min" 
                    min={props.extents.min} max={props.extents.max}
                    value={range.min}
                    onChange={(event) => {
                      console.log('input changed:', event)
                      props.updateRange({ min: event.target.value, max: range.max })
                    }} />
            <b className="px-5">-</b>
            <input  className="bg-gray-200 border rounded"
                    type="number" name="maxValue"
                    placeholder="Max" 
                    min={props.extents.min} max={props.extents.max}
                    value={range.max} 
                    onChange={(event) => props.updateRange({ min: range.min, max: event.target.value })} />
          </div>
        </div>
      </div>
    )
  }
}
