import React from 'react'

// props: index, itemsPerPage, goBack, goForward
export default function Pagination(props) {
  var pageStart = (props.index * props.itemsPerPage) + 1
  var pageEnd = (props.index + 1) * props.itemsPerPage;
  if (pageEnd > props.totalHits) {
      pageEnd = props.totalHits;
  }

  return(
    <div className="p-4 flex items-baseline">
      <a href="#" className="underline font-bold text-gray-700 text-sm" onClick={() => props.goBack()}>
        Back
      </a>
      <span className="ml-2 text-sm text-gray-600">showing</span>
      <div className="ml-2 font-bold">{pageStart}-{pageEnd}</div>
      <span className="ml-2 text-sm text-gray-600">of</span>
      <p className="ml-2 font-bold">{props.totalHits}</p>
      <a href="#" className="ml-2 underline font-bold text-gray-700 text-sm" onClick={() => props.goForward()}>
        Next
      </a>
    </div>
  )
}